#include <qmenubar.h>
#include <qmessagebox.h>
#include <qdatetime.h>
#include "mainwindow.h"
#include "mdiwindow.h"
#include "flush.h"
#include "loglistviewitem.h"
#include "include/sql.h"

void MainWindow::slot_flush_threads()
{
	if(SQL::sql_query("flush threads"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
  }

void MainWindow::slot_flush_hosts()
{
	if(SQL::sql_query("flush hosts"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
}

void MainWindow::slot_flush_logs()
{
	if(SQL::sql_query("flush logs"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
 }

void MainWindow::slot_flush_privilages()
{
	if(SQL::sql_query("flush privileges"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
}

void MainWindow::slot_flush_status()
{
	if(SQL::sql_query("flush status"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
 }

void MainWindow::slot_flush_tables()
{
	if(SQL::sql_query("flush tables"))
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&mysql)));
 }

void MainWindow::slot_flush()
{
	MDIWindow* z = new MDIWindow(workspace, 0, WDestructiveClose);

	Flush *flush = new Flush(&mysql,z);
	
    z->setCentralWidget(flush);
			 
    z->setCaption(tr("Flush"));

	z->setFixedSize( 171, 72 ); 

	z->show();
}
